/**
 * monologue.js - EventEmitter replacement with AMQP-style bindings and other advanced features. Compatible with postal.js's API.
 * Author: Jim Cowart (http://freshbrewedcode.com/jimcowart)
 * Version: v0.2.1
 * Url: https://github.com/postaljs/monologue.js
 * License(s): MIT, GPL
 */
(function(t,i){"object"==typeof module&&module.exports?module.exports=i(require("lodash"),require("riveter")):"function"==typeof define&&define.amd?define(["lodash","riveter"],function(n,s){return i(n,s,t)}):t.Monologue=i(t._,t.riveter,t)})(this,function(t,i){var n={cache:{},regex:{},compare:function(i,n){var s,e,o,c=this.cache[n]&&this.cache[n][i];return"undefined"!=typeof c?c:((e=this.regex[i])||(s="^"+t.map(i.split("."),function(t){var i="";return o&&(i="#"!==o?"\\.\\b":"\\b"),i+="#"===t?"[\\s\\S]*":"*"===t?"[^.]+":t,o=t,i}).join("")+"$",e=this.regex[i]=new RegExp(s)),this.cache[n]=this.cache[n]||{},this.cache[n][i]=c=e.test(n),c)},reset:function(){this.cache={},this.regex={}}},s=function(){var i;return function(n){var s=!1;return t.isString(n)?(s=n===i,i=n):(s=t.isEqual(n,i),i=t.clone(n)),!s}},e=function(){var i=[];return function(n){var s=!t.any(i,function(i){return t.isObject(n)||t.isArray(n)?t.isEqual(n,i):n===i});return s&&i.push(n),s}},o=function(t,i,n){this.topic=t,this.callback=i,this.context=null,this.constraints=[],this.emitter=n};t.extend(o.prototype,{withContext:function(t){return this.context=t,this},unsubscribe:function(){this.emitter._subscriptions[this.topic]=t.without(this.emitter._subscriptions[this.topic],this)},disposeAfter:function(i){if(t.isNaN(i)||0>=i)throw"The value provided to disposeAfter (maxCalls) must be a number greater than zero.";var n=this,s=t.after(i,function(){n.unsubscribe()}),e=n.callback;return n.callback=function(){e.apply(n.context,arguments),s()},n},once:function(){return this.disposeAfter(1)}}),o.prototype.off=o.prototype.unsubscribe,t.extend(o.prototype,{defer:function(){var t=this.callback;return this.callback=function(i,n){var s=this;setTimeout(function(){t.call(s,i,n)},0)},this},distinctUntilChanged:function(){return this.withConstraint(new s),this},distinct:function(){return this.withConstraint(new e),this},withConstraint:function(i){if(!t.isFunction(i))throw"Predicate constraint must be a function";return this.constraints.push(i),this},withConstraints:function(i){var n=this;return t.isArray(i)&&t.each(i,function(t){n.withConstraint(t)}),n},withDebounce:function(i){if(t.isNaN(i))throw"Milliseconds must be a number";var n=this.callback;return this.callback=t.debounce(n,i),this},withDelay:function(i){if(t.isNaN(i))throw"Milliseconds must be a number";var n=this.callback;return this.callback=function(t){setTimeout(function(){n(t)},i)},this},withThrottle:function(i){if(t.isNaN(i))throw"Milliseconds must be a number";var n=this.callback;return this.callback=t.throttle(n,i),this}});var c=function(){},r=function(i,n){if(c.resolver.compare(i.topic,n.topic)&&t.all(i.constraints,function(t){return t(n.data,n)})&&"function"==typeof i.callback)try{i.callback.apply(i.context,[n.data,n])}catch(s){c.debug&&"undefined"!=typeof console&&"function"==typeof console.log&&(console.log("Monologue Emit Exception Caught"),console.log(s)),i.failed=!0,this._trackErrors&&(this._yuno||(this._yuno=[]),this._yuno.push({def:i,env:n,exception:s}))}};return c.prototype={on:function(t,i){var n=this;return n._subscriptions=n._subscriptions||{},n._subscriptions[t]=n._subscriptions[t]||[],n._subscriptions[t].push(new o(t,i,n)),n._subscriptions[t][n._subscriptions[t].length-1]},once:function(t,i){return this.on(t,i).once()},off:function(i,n){switch(this._subscriptions=this._subscriptions||{},arguments.length){case 0:t.each(this._subscriptions,function(i){t.each(i,function(t){t.unsubscribe()})}),this._subscriptions={};break;case 1:var s="[object String]"===Object.prototype.toString.call(i)?"topic":i instanceof o?"def":"context";switch(s){case"topic":if(this._subscriptions[i])for(;this._subscriptions[i].length;)this._subscriptions[i].pop().unsubscribe();break;case"context":t.each(this._subscriptions,function(n){t.each(t.clone(n),function(t,s){t.context===i&&(t.unsubscribe(),n.splice(s,1))})});break;default:i.unsubscribe()}break;default:t.each(t.clone(this._subscriptions[i]),function(t,s){t.context===n&&(t.unsubscribe(),this._subscriptions[i].splice(s,1))},this)}},emit:function(i,n){var s=this.getEnvelope(i,n);this._subscriptions=this._subscriptions||{},t.each(this._subscriptions,function(t){for(var i,n=0,e=t.length;e>n;)(i=t[n++])&&r.call(this,i,s)},this)},getEnvelope:function(t,i){return{topic:t,timeStamp:new Date,data:i}}},c.resolver=n,c.debug=!1,c.SubscriptionDefinition=o,i(c),c.mixInto=function(t){i.punch(t,c.prototype)},c});